<template>
  <form class="header__search" @submit.prevent="submit">
    <input type="text" placeholder="Search..." v-model="searchValue" @input="submit"/>
    <button type="submit">
      <svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 56 56"><path fill="currentColor" d="M23.957 41.77a18.02 18.02 0 0 0 10.477-3.376l11.109 11.11a2.658 2.658 0 0 0 1.898.773c1.524 0 2.625-1.172 2.625-2.672c0-.703-.234-1.359-.75-1.874L38.277 34.668c2.32-3.047 3.703-6.82 3.703-10.922c0-9.914-8.109-18.023-18.023-18.023c-9.937 0-18.023 8.109-18.023 18.023S14.02 41.77 23.957 41.77m0-3.891c-7.758 0-14.133-6.398-14.133-14.133c0-7.734 6.375-14.133 14.133-14.133c7.734 0 14.133 6.399 14.133 14.133c0 7.735-6.399 14.133-14.133 14.133"/></svg>
    </button>
  </form>
</template>
<script setup lang="ts">
const {push} = useRouter()
const {query} = useRoute()
const searchValue = ref(query.q || '')
const searchTimer = ref(null)
const submit = () => {
  if (searchValue.value.length >= 3) {
    clearTimeout(searchTimer.value as any)
    searchTimer.value = setTimeout(() => {
      push({query: { q: searchValue.value }})
    }, 500) as any;
  }else {
    push({query: {}})
  }
}
</script>